Package org.apache.storm.perf.spout

## Class StringGenSpout

- java.lang.Object
- - org.apache.storm.topology.base.BaseComponent
  - - org.apache.storm.topology.base.BaseRichSpout
    - - org.apache.storm.perf.spout.StringGenSpout

- All Implemented Interfaces:
    `Serializable`, `ISpout`, `IComponent`, `IRichSpout`

      public class StringGenSpout
      extends BaseRichSpout

  Spout pre-computes a list with 30k fixed length random strings. Emits sequentially from this list, over and over again.
  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `StringGenSpout​(int strLen)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `ack​(Object msgId)` | Storm has determined that the tuple emitted by this spout with the msgId identifier has been fully processed.
    `void` | `declareOutputFields​(OutputFieldsDeclarer declarer)` | Declare the output schema for all the streams of this topology.
    `void` | `nextTuple()` | When this method is called, Storm is requesting that the Spout emit tuples to the output collector.
    `void` | `open​(Map<String,​Object> conf, TopologyContext context, SpoutOutputCollector collector)` | Called when a task for this component is initialized within a worker on the cluster.
    `StringGenSpout` | `withFieldName​(String fieldName)` |

    - ### Methods inherited from class org.apache.storm.topology.base.BaseRichSpout

      `activate, close, deactivate, fail`

    - ### Methods inherited from class org.apache.storm.topology.base.BaseComponent

      `getComponentConfiguration`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.storm.topology.IComponent

      `getComponentConfiguration`

- - ### Constructor Detail

    - #### StringGenSpout

          public StringGenSpout​(int strLen)

  - ### Method Detail

    - #### withFieldName

          public StringGenSpout withFieldName​(String fieldName)

    - #### declareOutputFields

          public void declareOutputFields​(OutputFieldsDeclarer declarer)

      Description copied from interface: `IComponent`
      Declare the output schema for all the streams of this topology.
      Parameters:
        `declarer` - this is used to declare output stream ids, output fields, and whether or not each output stream is a direct stream

    - #### open

          public void open​(Map<String,​Object> conf,
                           TopologyContext context,
                           SpoutOutputCollector collector)

      Description copied from interface: `ISpout`
      Called when a task for this component is initialized within a worker on the cluster. It provides the spout with the environment in which the spout executes.

      This includes the:

      Parameters:
        `conf` - The Storm configuration for this spout. This is the configuration provided to the topology merged in with cluster configuration on this machine.
        `context` - This object can be used to get information about this task's place within the topology, including the task id and component id of this task, input and output information, etc.
        `collector` - The collector is used to emit tuples from this spout. Tuples can be emitted at any time, including the open and close methods. The collector is thread-safe and should be saved as an instance variable of this spout object.

    - #### nextTuple

          public void nextTuple()

      Description copied from interface: `ISpout`
      When this method is called, Storm is requesting that the Spout emit tuples to the output collector. This method should be non-blocking, so if the Spout has no tuples to emit, this method should return. nextTuple, ack, and fail are all called in a tight loop in a single thread in the spout task. When there are no tuples to emit, it is courteous to have nextTuple sleep for a short amount of time (like a single millisecond) so as not to waste too much CPU.

    - #### ack

          public void ack​(Object msgId)

      Description copied from interface: `ISpout`
      Storm has determined that the tuple emitted by this spout with the msgId identifier has been fully processed. Typically, an implementation of this method will take that message off the queue and prevent it from being replayed.
      Specified by:
        `ack` in interface `ISpout`
      Overrides:
        `ack` in class `BaseRichSpout`